From rct@merkin.csap.af.mil Fri May 15 16:49 MET 1998
Received: from gatekeeper.rhein.de (gatekeeper.rhein.de [193.175.27.1])
	by hobbes.rhein.de (8.8.8/8.8.8) with ESMTP id QAA01360
	for <caronni@hobbes.rhein.de>; Fri, 15 May 1998 16:49:14 +0200 (MET DST)
Received: (from root@localhost)
	by gatekeeper.rhein.de (8.8.7-ws3/8.8.7-ws3)
	id QAA01728 for caronni@hobbes.rhein.de; Fri, 15 May 1998 16:08:37 +0200 (MET DST)
Received: from mail.acm.org (mail.acm.org [199.222.69.4])
	by gatekeeper.rhein.de (8.8.8-ws3/8.8.8-ws3) with ESMTP
	id QAA01677 for <caronni@hobbes.rhein.de>; Fri, 15 May 1998 16:08:11 +0200 (MET DST)
Received: from tik2.ethz.ch (tik2.ethz.ch [129.132.119.132]) by mail.acm.org (8.8.5/8.7.5) with ESMTP id KAA105758; Fri, 15 May 1998 10:03:14 -0400
Received: from mudd.csap.af.mil (mudd.csap.af.mil [192.203.1.250])
	by tik2.ethz.ch (8.8.8/8.8.8) with ESMTP id QAA25154
	for <skip@tik.ee.ethz.ch>; Fri, 15 May 1998 16:07:59 +0200 (MET DST)
Received: (from uucp@localhost) by mudd.csap.af.mil (8.7.5/8.7.3/CNS-4.0) id JAA18503; Fri, 15 May 1998 09:01:16 -0500 (CDT)
Received: from merkin.csap.af.mil(192.203.5.231) by mudd via smap (V2.0alpha)
	id xma018499; Fri, 15 May 98 09:01:14 -0500Received: from localhost (7811 bytes) by merkin.csap.af.mil
	via sendmail with P:stdio/R:force_smtp/T:smtp
	(sender: <rct>) (ident <rct> using unix)
	id <m0yaL99-00043GC@merkin.csap.af.mil>
	for <skip-info@skip.org>; Fri, 15 May 1998 09:07:39 -0500 (CDT)
	(Smail-3.2.0.96 1997-Jun-2 #1 built 1997-Aug-18)
Message-Id: <m0yaL99-00043GC@merkin.csap.af.mil>
From: rct@merkin.csap.af.mil (Bob Tracy - TDS)
Subject: Linux 2.1.X ENskip fixed!
To: skip-info@skip.org
Date: Fri, 15 May 1998 09:07:39 -0500 (CDT)
Cc: skip@tik.ee.ethz.ch
X-Mailer: ELM [version 2.4ME+ PL40 (25)]
MIME-Version: 1.0
Content-Transfer-Encoding: 7bit
Content-Type: multipart/mixed; boundary=ELM895241258-1514-0_
Content-Length: 7414
Status: OR


--ELM895241258-1514-0_
Content-Type: text/plain; charset=US-ASCII
Content-Transfer-Encoding: 7bit

(Gee, is this list dead or what?  My earlier announcement of the
Linux 2.1.X ENskip botch elicited exactly ZERO comments in this
forum and in private e-mail.)

It took a few days, but I found the problem.  It turns out that the
IP firewall code in Linux 2.1.X has been broken for a long time,
probably since early in the 2.1.X networking development cycle.
Specifically, not all the paths between the IPv4 layer and the physical
layer are covered by the firewall code, and in particular, the path
taken by a SYN_ACK packet ( ip_build_and_send_pkt() ) is not covered.

An official patch will probably appear in the 2.1.103 kernel: I
discovered the problem too late for inclusion in 2.1.102.  Attached
please find a revised ENskip kernel patch for Linux 2.1.101 that
includes a fix for the firewall code.

-- 
Bob Tracy               | "Microsoft's biggest and most dangerous
Trident Data Systems    |  contribution to the software industry may
AFIWC/TIPER             |  be the degree to which it has lowered user
rct@merkin.csap.af.mil  |  expectations."	- Esther Schlindler
                                                  OS/2 Magazine

--ELM895241258-1514-0_
Content-Type: text/plain; charset=US-ASCII
Content-Disposition: attachment; filename=patch101_ENskip
Content-Description: /usr/src/linux/.patch/patch101_ENskip
Content-Transfer-Encoding: 7bit

--- linux/include/net/sock.h.orig	Wed Apr 29 09:31:55 1998
+++ linux/include/net/sock.h	Wed Apr 29 09:32:48 1998
@@ -511,6 +511,14 @@
   	int			(*backlog_rcv) (struct sock *sk,
 						struct sk_buff *skb);  
 	void                    (*destruct)(struct sock *sk);
+
+#ifdef CONFIG_NET_SECURITY
+  /*
+   *	Security
+   */
+	short			authentication;
+	short			encryption;
+#endif
 };
 
 /* IP protocol blocks we attach to sockets.
--- linux/net/core/sock.c.orig	Wed Apr 29 09:31:55 1998
+++ linux/net/core/sock.c	Wed Apr 29 09:32:48 1998
@@ -285,6 +285,16 @@
 			sk->bsdism = valbool;
 			break;
 
+#ifdef CONFIG_NET_SECURITY
+		case SO_SECURITY_AUTHENTICATION:
+			sk->authentication = val;
+			break;
+
+		case SO_SECURITY_ENCRYPTION_TRANSPORT:
+			sk->encryption = val;
+			break;
+#endif
+
 		case SO_PASSCRED:
 			sock->passcred = valbool;
 			break;
@@ -435,6 +445,16 @@
 			v.val = sk->bsdism;
 			break;
 			
+#ifdef CONFIG_NET_SECURITY
+		case SO_SECURITY_AUTHENTICATION:
+			v.val = sk->authentication;
+			break;
+
+		case SO_SECURITY_ENCRYPTION_TRANSPORT:
+			v.val = sk->encryption;
+			break;
+#endif
+
 		case SO_RCVTIMEO:
 		case SO_SNDTIMEO:
 			lv=sizeof(struct timeval);
--- linux/net/ipv4/ip_forward.c.orig	Wed Apr 29 09:30:45 1998
+++ linux/net/ipv4/ip_forward.c	Wed May 13 11:02:54 1998
@@ -126,9 +126,10 @@
 	mtu = dev2->mtu;
 
 #ifdef CONFIG_NET_SECURITY
-	call_fw_firewall(PF_SECURITY, dev2, NULL, &mtu, NULL);
+	if (call_fw_firewall(PF_SECURITY, dev2, NULL, &mtu, NULL) < FW_ACCEPT)
+		return -1;
 #endif	
-	
+
 	/*
 	 *	In IP you never have to forward a frame on the interface that it 
 	 *	arrived upon. We now generate an ICMP HOST REDIRECT giving the route
@@ -137,6 +138,11 @@
 	if (rt->rt_flags&RTCF_DOREDIRECT && !opt->srr)
 		ip_rt_send_redirect(skb);
 	
+#ifdef CONFIG_NET_SECURITY
+	if (call_out_firewall(PF_SECURITY, dev2, NULL, (void *)2, &skb) < FW_ACCEPT)
+		return -1;
+#endif	
+
 	/*
 	 * We now may allocate a new buffer, and copy the datagram into it.
 	 * If the indicated interface is up and running, kick it.
--- linux/net/ipv4/ip_output.c.orig	Wed Apr 29 09:31:55 1998
+++ linux/net/ipv4/ip_output.c	Thu May 14 15:05:10 1998
@@ -74,6 +74,7 @@
 #include <linux/firewall.h>
 #include <linux/mroute.h>
 #include <linux/netlink.h>
+#include <linux/ipsec.h>
 
 /*
  *      Shall we try to damage output packets if routing dev changes?
@@ -99,7 +100,8 @@
 {
 	struct rtable *rt = (struct rtable *)skb->dst;
 	struct iphdr *iph;
-	
+	struct device *dev;
+
 	/* Build the IP header. */
 	if (opt)
 		iph=(struct iphdr *)skb_push(skb,sizeof(struct iphdr) + opt->optlen);
@@ -126,10 +128,24 @@
 		ip_options_build(skb, opt, daddr, rt, 0);
 	}
 
+	dev = rt->u.dst.dev;
+
+	if (call_out_firewall(PF_INET, dev, iph, NULL, &skb) < FW_ACCEPT)
+		goto drop;
+
 	ip_send_check(iph);
 
+#ifdef CONFIG_NET_SECURITY
+	if (call_out_firewall(PF_SECURITY, dev, NULL, (void *) 7, &skb) < FW_ACCEPT)
+		goto drop;
+#endif
+
 	/* Send it out. */
 	skb->dst->output(skb);
+	return;
+
+drop:
+	kfree_skb(skb);
 }
 
 int __ip_finish_output(struct sk_buff *skb)
@@ -309,6 +325,16 @@
 	if (call_out_firewall(PF_INET, dev, iph, NULL, &skb) < FW_ACCEPT) 
 		goto drop;
 
+#ifdef CONFIG_NET_SECURITY	
+	/* Add an IP checksum (must do this before SECurity because
+	 * of possible tunneling).
+	 */
+	ip_send_check(iph);
+	if (call_out_firewall(PF_SECURITY, dev, NULL, (void *) 4, &skb) < FW_ACCEPT)
+		goto drop;
+	iph = skb->nh.iph;
+	/* Don't update tot_len, as the dev->mtu is already decreased. */
+#endif
 	/* This can happen when the transport layer has segments queued
 	 * with a cached route, and by the time we get here things are
 	 * re-routed to a device with a different MTU than the original
@@ -331,9 +357,10 @@
 	if (tot_len > rt->u.dst.pmtu)
 		goto fragment;
 
+#ifndef CONFIG_NET_SECURITY
 	/* Add an IP checksum. */
 	ip_send_check(iph);
-
+#endif
 	skb->priority = sk->priority;
 	skb->dst->output(skb);
 	return;
@@ -397,6 +424,9 @@
 	int nfrags=0;
 	struct ip_options *opt = ipc->opt;
 	int df = htons(IP_DF);
+#ifdef CONFIG_NET_SECURITY
+	int fw_res;
+#endif
 
 	if (sk->ip_pmtudisc == IP_PMTUDISC_DONT ||
 		(rt->u.dst.mxlock&(1<<RTAX_MTU)))
@@ -555,6 +585,13 @@
 		if(!err && offset == 0 && 
 		   call_out_firewall(PF_INET, rt->u.dst.dev, skb->nh.iph, NULL, &skb) < FW_ACCEPT)
 			err = -EPERM;
+#ifdef CONFIG_NET_SECURITY
+		if ((fw_res=call_out_firewall(PF_SECURITY, rt->u.dst.dev, NULL, (void *) 6, &skb))<FW_ACCEPT)
+		{
+			if (fw_res != FW_QUEUE)
+				err= -EPERM;
+		}
+#endif		
 
 		if (err) { 
 			ip_statistics.IpOutDiscards++;
@@ -602,6 +639,9 @@
 	struct sk_buff *skb;
 	int df;
 	struct iphdr *iph;
+#ifdef CONFIG_NET_SECURITY
+	int fw_res;
+#endif
 
 	/*
 	 *	Try the simple case first. This leaves fragmented frames, and by
@@ -672,6 +712,16 @@
 
 	if(!err && call_out_firewall(PF_INET, rt->u.dst.dev, iph, NULL, &skb) < FW_ACCEPT) 
 		err = -EPERM;
+#ifdef CONFIG_NET_SECURITY
+	if ((fw_res=call_out_firewall(PF_SECURITY, rt->u.dst.dev, NULL, (void *) 5, &skb))<FW_ACCEPT)
+	{
+		kfree_skb(skb);
+		if (fw_res != FW_QUEUE)
+			return -EPERM;
+		else
+			return 0;
+	}
+#endif
 
 	if (err) { 
 		kfree_skb(skb);
--- linux/net/Config.in.orig	Wed Apr 29 09:31:55 1998
+++ linux/net/Config.in	Wed Apr 29 09:32:49 1998
@@ -10,6 +10,9 @@
   tristate 'Netlink device emulation' CONFIG_NETLINK_DEV
 fi
 bool 'Network firewalls' CONFIG_FIREWALL
+if [ "$CONFIG_FIREWALL" = "y" ]; then
+  bool 'Network security (ENskip support)' CONFIG_NET_SECURITY
+fi
 bool 'Network aliasing'  CONFIG_NET_ALIAS
 bool 'Socket Filtering'  CONFIG_FILTER
 tristate 'Unix domain sockets' CONFIG_UNIX
--- linux/net/netsyms.c.orig	Sat May  9 17:20:13 1998
+++ linux/net/netsyms.c	Sat May  9 17:22:28 1998
@@ -214,6 +214,7 @@
 #endif
 EXPORT_SYMBOL(ip_id_count);
 EXPORT_SYMBOL(ip_send_check);
+EXPORT_SYMBOL(ip_forward);
 EXPORT_SYMBOL(ip_fragment);
 EXPORT_SYMBOL(inet_family_ops);
 EXPORT_SYMBOL(in_aton);

--ELM895241258-1514-0_--

